## This program is to retrive the protein and DNA sequences for a given set of Gene ID of C .Necator H16
## Give the GeneID it retrieve the Protein, Nucleotide sequences as well as the EC number, if available
## Alternatively it provides the Sequences, GEne IDs when the query is EC numbers
## Benefits: Less human effort and secure internal search
## Adaptability: Can be easily adapted for any other organism when required

file="query.txt"

#### Do not change below ths line #######

rm result*

gene_or_ec=$(awk 'NR==1 {print $1}' $file | cut -c1-3)

RED='\033[0;31m'
NC='\033[0m' # No Color
if [[ $gene_or_ec == "" ]]
then
printf "${RED} ERROR: Input query file is empty - Check your Input ${NC}\n"
#echo -e "{RED} ERROR: Input query file is empty - Check your Input"
exit
fi

grep -nr '>' store/dna-newgeneid.fasta | sed -e 's\:\ \' | sed -e 's\>\ \' >  line-num-DNA.dat
grep -nr '>' store/protein-newgeneid.fasta | sed -e 's\:\ \' | sed -e 's\>\ \' > line-num-PROT.dat

total=$(wc -l $file | awk '{print $1}')

echo "#################################################" >> psedugene.tmpl
echo "# pseudo gene  OR no information about OLD gene #" >> psedugene.tmpl
echo "#################################################" >> psedugene.tmpl

if [[ $gene_or_ec == "H16" || $gene_or_ec == "PHG" ]]
then
data="store/new-gene-old-gene-genename-protid.dat"
else
data="store/newgene-oldgene-ecnumber.dat"
for ((i=1; i<=$total; i++))
do
aa=$(awk 'NR==xx {print $1}' xx="$i" $file)
bb=$(grep $aa store/newgene-oldgene-ecnumber.dat | awk '{print $2}')
echo $bb | tr -s ' '  '\n' >> ec-oldgene.tmpl

cc=$(grep $aa store/newgene-oldgene-ecnumber.dat | awk '{print $3}')
echo $cc | tr -s ' '  '\n' >> ec-oldgene-1.tmpl 
done
file="ec-oldgene.tmpl"
paste ec-oldgene.tmpl ec-oldgene-1.tmpl > result-Gene-ECnumber.txt
fi


total=$(wc -l $file | awk '{print $1}')

################################################

for ((i=1; i<=$total; i++))
do
oldgene=$(awk 'NR==xx {print $1}' xx="$i" $file)
chk=$(grep -q $oldgene $data || echo $?)

if [[ $chk == 1 ]]
then
echo $oldgene  >> psedugene.tmpl
else
newgene=$(grep $oldgene $data | awk '{print $1}')
echo $oldgene >> oldgene_1.tmpl
echo $oldgene $newgene

newgeneline=$(grep -nr $newgene line-num-DNA.dat | sed -e 's\:\ \' | awk '{print $1}')
newgeneline_plusone=$((newgeneline + 1))

line1=$(awk 'NR==xx {print $1}' xx="$newgeneline" line-num-DNA.dat)
line2=$(awk 'NR==xx {print $1}' xx="$newgeneline_plusone" line-num-DNA.dat)

awk 'NR>=aa && NR<bb {print}' aa="$line1" bb="$line2" store/dna-newgeneid.fasta >> result-dna.tmpl

newgeneline=$(grep -nr $newgene line-num-PROT.dat | sed -e 's\:\ \' | awk '{print $1}')
newgeneline_plusone=$((newgeneline + 1))

line1=$(awk 'NR==xx {print $1}' xx="$newgeneline" line-num-PROT.dat)
line2=$(awk 'NR==xx {print $1}' xx="$newgeneline_plusone" line-num-PROT.dat)

awk 'NR>=aa && NR<bb {print}' aa="$line1" bb="$line2" store/protein-newgeneid.fasta >> result-protein.tmpl

fi
done


#########################################
### Replace the New gene ID to Old one ##
#########################################

awk '{print $1}' result-dna.tmpl | sed -e "\$a >" >  dna.tmpl
awk '{print $1}' result-protein.tmpl | sed -e "\$a >" >  protein.tmpl
awk '{print $1}' oldgene_1.tmpl > list

total=$(grep '>' dna.tmpl | wc -l | awk '{print $1}')

grep -nr '>' dna.tmpl | sed -e 's\:\ \' | awk '{print $1}' > dna-lines
grep -nr '>' protein.tmpl | sed -e 's\:\ \' | awk '{print $1}' > protein-lines


for ((i=1; i<$total; i++))
do
line=$(awk 'NR==xx {print $1}' xx="$i" dna-lines)
id1=$(awk 'NR==xx {print $1}' xx="$line" dna.tmpl | sed 's/^>//')
id2=$(awk 'NR==xx {print $1}' xx="$i" list)
sed -e s/$id1/$id2/g dna.tmpl > t1.tmpl
mv t1.tmpl dna.tmpl

line=$(awk 'NR==xx {print $1}' xx="$i" protein-lines)
id1=$(awk 'NR==xx {print $1}' xx="$line" protein.tmpl | sed 's/^>//')
id2=$(awk 'NR==xx {print $1}' xx="$i" list)
sed -e s/$id1/$id2/g protein.tmpl > t2.tmpl
mv t2.tmpl protein.tmpl

done

grep -F -f list store/newgene-oldgene-ecnumber.dat | awk '{print $2 "   " $3}' > result-gene-ecnumber.txt

sed '$d' protein.tmpl > result-protein.txt
sed '$d' dna.tmpl > result-nucleotide.txt
mv psedugene.tmpl result-notes.txt
cat result-notes.txt

rm *.tmpl list dna-lines protein-lines line-num-DNA.dat line-num-PROT.dat
